
require "Process_slicer"  
require "note_column_functions"
require "effects_column_functions"




------------------------------------------
--Set up Preferences file
------------------------------------------
--create preferences xml
options = renoise.Document.create {
  include_fx = true,
  leave_one = false
}

 --assign options-object to .preferences so renoise knows to load and update it with the tool
renoise.tool().preferences = options
------------------------------------------
--------------------------------------------

--dialog global
local my_dialog
--------------------------------------------------------------
--GUI
--------------------------------------------------------------
function invoke_gui()
  
  --1 dialog at a time
  if (my_dialog and my_dialog.visible) then -- only allows one dialog instance
    my_dialog:close()
    return
  end

  --viewbuilder object
  local vb = renoise.ViewBuilder()
  
  ---------------------------------------
  --executes when re-order button pressed
  ----------------------------------------
  local function re_order_button()
    if vb.views["popup"].value == 1 then
      process_single_track_in_pattern() 
    elseif vb.views["popup"].value  == 2 then  
     -- process_selection_in_pattern()
     main_selection_in_pattern()
    elseif vb.views["popup"].value  == 3 then
      process_whole_track()
    end 
  end
  
  --dialog content
  local dialog_content = vb:column {
   
      margin = 8,
      
      vb:vertical_aligner {
       mode = "center",
       spacing = 8,
      
      vb:column {
       style = "group",
       margin = 7,
       
      vb:text {
       text = "Range:" 
      },
      
      vb:popup {
       value = 1,
       id = "popup",
       width = 120,
       items = {
         "All Tracks in Song",
         "Track in Song",
         
        },           
       }, 
       
       vb:text {
       text = "Include Effects Columns:" 
      },
      
      vb:checkbox{
      active = true,
      value =  options.include_fx.value, --`not` preserve columns as GUI label is left align
      notifier = function()
                   --set bool for including fx scan or not
                   options.include_fx.value = not options.include_fx.value
                   --set `Min of 1 Effects Column:` checkbox to be active or not
                   vb.views["min"].active = options.include_fx.value
                 end
      },
      
      
         vb:text {
       text = "Min of 1 Effects Column:" 
      },
      
      vb:checkbox{
      id = "min",
      active = options.include_fx.value,
      value =  options.leave_one.value, --`not` preserve columns as GUI label is left align
      notifier = function()options.leave_one.value = not options.leave_one.value
                 end
      },
       
       
      },--column
      
      vb:horizontal_aligner {
       mode = "center",
       margin = 4,
      
      vb:button {
       text = "Apply",
       id = "button",
       height = 24,
       width = 110,
       notifier = function()
                    
                    --process Single Track note columns only
                    if vb.views["popup"].value == 2 then
                      process_single_track()
                      if options.include_fx.value then
                        --all tracks fx
                        process_single_track_fx()
                      end
                      return --job done
                    end 
                    --process All Tracks
                    if vb.views["popup"].value == 1 then
                      --all tracks notes
                      process()
                      --and all track fx
                      if options.include_fx.value then
                        --all tracks fx
                        process_fx()
                      end
                    end
                  end,
      },           
     }
    }
   }
  ------------------------------------------------------      
   --key Handler
  local function my_keyhandler_func(dialog, key)
  
   --scrolling the range popup with the up and down keys
 --[[  if key.name == "down" then
     if vb.views["popup"].value < 3 then
       vb.views["popup"].value = vb.views["popup"].value + 1
     else 
       return
     end
   elseif key.name == "up" then
     if vb.views["popup"].value > 1 then
       vb.views["popup"].value = vb.views["popup"].value - 1
     else
       return
     end 
     
   --executing re-order button with return key
   elseif key.name == "return" then
     re_order_button()--]]
     
   --closing the dialog with escape
   if not (key.modifiers == "" and key.name == "esc") then
      return key
   else
     dialog:close()
   end
  end
  
  my_dialog = renoise.app():show_custom_dialog("To Active Columns", dialog_content, my_keyhandler_func)
end


--------------------------------
--Keybindings
--------------------------------
renoise.tool():add_keybinding {
  name = "Global:Tools:Set Track Widths To Active Columns",
  invoke = function() invoke_gui()
  end  
}

renoise.tool():add_menu_entry {
  name = "Main Menu:Tools:Ledger`s Scripts:Set Track Widths To Active Columns",
  invoke = function() invoke_gui()
  end
}

----------------------------------------------------------------------------------------
--Process slicers Current track or all tracks --called in Apply button notifier function
----------------------------------------------------------------------------------------
--Current track
function process_single_track()
  --single_track = true
  local slicer = ProcessSlicer(function() set_track_to_active_columns(true)end)
  slicer:start()
end
-----------------------------------------------------------------------
--All tracks
function process()
 -- single_track = false
  local slicer = ProcessSlicer(function() set_track_to_active_columns(false)end)
  slicer:start()
end
-----------------------------------------------------------------------
--EFFECTS
-----------------------------------------------------------------------
--Current track
function process_single_track_fx()
 -- single_track = true
  local slicer = ProcessSlicer(function() set_track_to_active_fx_columns(true)end)
  slicer:start()
end

--All tracks
function process_fx()
 -- single_track = false
  local slicer = ProcessSlicer(function() set_track_to_active_fx_columns(false)end)
  slicer:start()
end

