-----------------------------------------------------------------------
-- helper function returns table with track index and a bool 
-- true if note track, false if group send or master
-----------------------------------------------------------------------
local function get_type_of_tracks() 

  local track_table = renoise.song().tracks
  local note_tracks = {}  --incrementor
  local NOTE_TRACK = 1
  
  for num,track in ipairs(track_table) do
   
    if track.type == NOTE_TRACK then
      note_tracks[num] = true
    else
      note_tracks[num] = false
    end    
  end   
 return note_tracks
end


-----------------------------------------------------------------------
--main function
-----------------------------------------------------------------------
function set_track_to_active_columns(single_track)


  local all_patterns = #renoise.song().patterns
  
  local current_pattern_track
  local column_adjusted_to
  
  --bools
  local found_pattern
  local note_found
  
------------------------------------------------------
  local function one_track_scan(track)
    --reset for each new track
    note_found = false 
    found_pattern = false
    
    for note_col = 12,1,-1 do --each column starting from 12
      local track_name = renoise.song().tracks[track].name
      renoise.app():show_status("`Set Track To Active Columns` Tool: (Checking: "..track_name.." / Column: "..note_col..")")
    
      if note_found == true then
        break
      end
    
      for pattern = 1, all_patterns do --each pattern
        
        --yield every 50 pattern_columns scanned
        if ((pattern % 50) == 0) then
          coroutine.yield()
        end
        
        --get length of current pattern
        local pattern_length = renoise.song().patterns[pattern].number_of_lines  
        
        if note_found == true then
          break
        end 
        
        current_pattern_track = renoise.song():pattern(pattern):track(track)--joule
        
        if not current_pattern_track.is_empty then --joule
            local lines = current_pattern_track:lines_in_range(1, pattern_length)--joule
            
            for i, line in ipairs(lines) do  --each cell--joule
       
              if  line:note_column(note_col).note_value < 120 then -- then ----(120 = note-off, 121 = empty)
                note_found = true
                found_pattern = (pattern)
                --set visible columns
                renoise.song():track(track).visible_note_columns = note_col --joule
                column_adjusted_to = note_col
              break
            end  
          end --for line_index
        end --for pattern 
      end 
      --yield processing to renoise after each column in song scanned
      --necessary for songs less than 50 patterns in length
      coroutine.yield()
    end --for note_col
    
    --status
    --multi-track finished status
    if not single_track then
      renoise.app():show_status("`Set Track To Active Columns` Tool : (Completed)")
    else
      --single track finished status
      if found_pattern then
        renoise.app():show_status("`Set Track To Active Columns` Tool : (Completed.  Right-Most Note found in:  Column: "..column_adjusted_to.." / Pattern: "..(found_pattern - 1)..")")
      else
        renoise.song().tracks[track].visible_note_columns = 1 --set columns
       renoise.app():show_status("`Set Track To Active Columns` Tool : (Completed.  Set Track "..track.." To 1 Column , No Notes Were Found)")
      end
    end
    
    if not note_found then
      renoise.song():track(track).visible_note_columns = 1
    end 
  end --one track scan function()
  -----------------------------------------------------
  
  
  if single_track then
    local track = renoise.song().selected_track_index
    one_track_scan(track)
  else --process all tracks
    for track,note_track in ipairs(get_type_of_tracks()) do
      if note_track then
        one_track_scan(track)
      end
    end
  end
end --main
